package me.wazup.hideandseek.managers;

import java.lang.reflect.InvocationTargetException;
import org.bukkit.entity.Player;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

public class ClickableTextManager
{
    private final Method fromLegacyText;
    private Constructor<?> textComponentConstructor;
    private final Constructor<?> clickEvent;
    private final Class<Enum> actionEnum;
    private final Enum<?> RUN_COMMAND;
    private final Method setClickEvent;
    private final Method sendMessage;
    
    public ClickableTextManager() {
        final Class<?> forName = Class.forName("net.md_5.bungee.api.chat.TextComponent");
        this.fromLegacyText = forName.getMethod("fromLegacyText", String.class);
        final Object[] baseComponent = this.getBaseComponent("Test");
        final Constructor[] constructors = forName.getConstructors();
        final int length = constructors.length;
        int i = 0;
        while (i < length) {
            final Constructor textComponentConstructor = constructors[i];
            try {
                textComponentConstructor.newInstance(baseComponent);
                this.textComponentConstructor = textComponentConstructor;
            }
            catch (final Exception ex) {
                ++i;
                continue;
            }
            break;
        }
        if (this.textComponentConstructor == null) {
            throw new NoSuchMethodException();
        }
        final Class<?> forName2 = Class.forName("net.md_5.bungee.api.chat.ClickEvent");
        this.actionEnum = (Class<Enum>)this.getNestedClass(forName2, "Action");
        this.RUN_COMMAND = Enum.valueOf((Class<Enum<?>>)this.actionEnum, "RUN_COMMAND");
        this.clickEvent = forName2.getConstructor(this.actionEnum, String.class);
        this.setClickEvent = forName.getMethod("setClickEvent", Class.forName("net.md_5.bungee.api.chat.ClickEvent"));
        this.sendMessage = this.getNestedClass(Class.forName("org.bukkit.entity.Player"), "Spigot").getMethod("sendMessage", Class.forName("net.md_5.bungee.api.chat.BaseComponent"));
    }
    
    private Class<?> getNestedClass(final Class<?> clazz, final String anObject) {
        for (final Class clazz2 : clazz.getClasses()) {
            if (clazz2.getSimpleName().equals(anObject)) {
                return clazz2;
            }
        }
        return null;
    }
    
    private Object[] getBaseComponent(final String s) {
        return (Object[])this.fromLegacyText.invoke(null, s);
    }
    
    private Object getTextComponent(final String s, final String str) {
        final Object instance = this.textComponentConstructor.newInstance(this.getBaseComponent(s));
        this.setClickEvent.invoke(instance, this.clickEvent.newInstance(this.RUN_COMMAND, "/" + str));
        return instance;
    }
    
    private Object getSpigot(final Player obj) {
        return Player.class.getMethod("spigot", (Class<?>[])new Class[0]).invoke(obj, new Object[0]);
    }
    
    public void sendMessage(final Player player, final String s, final String s2) {
        try {
            this.sendMessage.invoke(this.getSpigot(player), this.getTextComponent(s, s2));
        }
        catch (final IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException | ClassNotFoundException | InstantiationException ex) {
            ((Throwable)ex).printStackTrace();
        }
    }
}
